/*
 *   senator - ASF video stream server
 *   Copyright (C) 2002  anonymous author
 *
 *
 *  senator is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  Senator is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *	
 *  You should have received a copy of the GNU General Public License
 *  along with senator; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 */
    
#ifndef CASFFile_H_INCLUDED
#define CASFFile_H_INCLUDED

#include <string>
#include "types.h"

#define FILE_NOT_FOUND		0
#define ILLEGAL_REQUEST		1
#define FILE_OPENED		2

class CASFFile{

private:
	FILE		*_fileHandler;
	std::string	_fileName;
	bool		_opened;

	FILEHEADER	*_fileHeader;
	CHUNKSAVE 	*subchunk;
	CHUNKSAVE	chunk;

	unsigned short  _asfHeaderSize;
	int		_headerCount;

// debug functions
	void	printChunkData(const GUID &guid);

// general asf file parse functions
	int	parseChunk(CHUNKSAVE *chunk);
	int	executeChunckFunction(CHUNKSAVE *chunk);

// functions to read blocks from the file
	int	readFileHeader(CHUNKSAVE *chunk);
	int	readASFFileHeader(CHUNKSAVE *chunk);

public:
	CASFFile(const std::string &fileName);
	~CASFFile();

	int	open();
	int	close();
	int	parseFile();
	
	void	getFileHeader(FILEHEADER *buffer);
	void	getASFHeader(void *buffer);
	void	getFrame(void *buffer,int packetOffset);
	int	getASFHeaderSize();

};

#endif // CASFFile_h_included
