/*
 *   senator - ASF video stream server
 *   Copyright (C) 2002  anonymous author
 *
 *
 *  senator is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  Senator is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *	
 *  You should have received a copy of the GNU General Public License
 *  along with senator; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 */

#ifndef TYPES_H_INCLUDED
#define TYPES_H_INCLUDED

//---------------------------------------------------------------
// make some type defs for system independent compiling
//---------------------------------------------------------------
typedef unsigned int 		ASF_uint32;
typedef unsigned char 		ASF_uchar;
typedef	unsigned short		ASF_ushort;
typedef int 			ASF_int32;
typedef char 			ASF_char;
typedef	short			ASF_short;

#ifndef WIN32
typedef long long int		ASF_uint64;
#else
typedef unsigned __int64	ASF_uint64;
#endif

//===============================================================
// ASF file format struct
//
// more information about the ASF file format can be found in
// the ASF file specification supplied by Microsoft
//===============================================================

//---------------------------------------------------------------
// 16 byte unique data ID
//---------------------------------------------------------------
#ifndef WIN32
#ifndef GUID_DEFINED
#define GUID_DEFINED
typedef struct  _GUID {
	ASF_uint32	Data1;
	ASF_ushort 	Data2;
	ASF_ushort 	Data3;
	ASF_uchar 	Data4[8];
}	GUID;
#endif // !GUID_DEFINED
#else
#include <windows.h>
#endif // WIN32

//---------------------------------------------------------------
// data chunk
//---------------------------------------------------------------
typedef struct chunk_save_st {
	GUID 		guid;
	ASF_uint64	len;
	void 		*data;
	struct 		chunk_save_st *next;
} CHUNKSAVE;

//---------------------------------------------------------------
// fileheader chunk
//---------------------------------------------------------------
typedef struct fileheader_st {
	GUID 		clientGUID;
	ASF_uint64 	filesize;
	ASF_uint64 	fileCreateTime;
	ASF_uint64 	numPackets;
	ASF_uint64 	timeAtEnd;
	ASF_uint64 	playDuration;
	ASF_uint32 	timeAtStart;
	ASF_uint32 	unknown1;
	ASF_uint32 	unknown2;
	ASF_uint32 	packetSize;
	ASF_uint32 	packetSize2;
	ASF_uint32 	uncompressedSize;
} FILEHEADER;


//---------------------------------------------------------------
// information about the file. This is a custom struct that 
// can be accessed everywhere in the code 
//---------------------------------------------------------------
struct globalinfo_st {
	int 		verbose;
	void 		*fileheader;
	char 		*ofname;
	int 		packetlen;
	int 		numpackets;
};

typedef struct guidaction_st {
	GUID 		*guid;
	char		*name;
	int			fn;		// used for the switch
} GUIDACTION;



#endif //TYPES_H_INCLUDED
